// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteeringStamped.idl
// generated code does not contain a copyright notice
#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `data`
#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering__functions.h"

bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(msg);
    return false;
  }
  // data
  if (!four_wheel_steering_msgs__msg__FourWheelSteering__init(&msg->data)) {
    four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(msg);
    return false;
  }
  return true;
}

void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // data
  four_wheel_steering_msgs__msg__FourWheelSteering__fini(&msg->data);
}

bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * lhs, const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // data
  if (!four_wheel_steering_msgs__msg__FourWheelSteering__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * input,
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // data
  if (!four_wheel_steering_msgs__msg__FourWheelSteering__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

four_wheel_steering_msgs__msg__FourWheelSteeringStamped *
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__create()
{
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg = (four_wheel_steering_msgs__msg__FourWheelSteeringStamped *)malloc(sizeof(four_wheel_steering_msgs__msg__FourWheelSteeringStamped));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(four_wheel_steering_msgs__msg__FourWheelSteeringStamped));
  bool success = four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__destroy(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg)
{
  if (msg) {
    four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(msg);
  }
  free(msg);
}


bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__init(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped * data = NULL;
  if (size) {
    data = (four_wheel_steering_msgs__msg__FourWheelSteeringStamped *)calloc(size, sizeof(four_wheel_steering_msgs__msg__FourWheelSteeringStamped));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__fini(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence *
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__create(size_t size)
{
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array = (four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence *)malloc(sizeof(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__destroy(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array)
{
  if (array) {
    four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__fini(array);
  }
  free(array);
}

bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * lhs, const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!four_wheel_steering_msgs__msg__FourWheelSteeringStamped__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * input,
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(four_wheel_steering_msgs__msg__FourWheelSteeringStamped);
    four_wheel_steering_msgs__msg__FourWheelSteeringStamped * data =
      (four_wheel_steering_msgs__msg__FourWheelSteeringStamped *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!four_wheel_steering_msgs__msg__FourWheelSteeringStamped__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
