// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice
#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
four_wheel_steering_msgs__msg__FourWheelSteering__init(four_wheel_steering_msgs__msg__FourWheelSteering * msg)
{
  if (!msg) {
    return false;
  }
  // front_steering_angle
  // rear_steering_angle
  // front_steering_angle_velocity
  // rear_steering_angle_velocity
  // speed
  // acceleration
  // jerk
  return true;
}

void
four_wheel_steering_msgs__msg__FourWheelSteering__fini(four_wheel_steering_msgs__msg__FourWheelSteering * msg)
{
  if (!msg) {
    return;
  }
  // front_steering_angle
  // rear_steering_angle
  // front_steering_angle_velocity
  // rear_steering_angle_velocity
  // speed
  // acceleration
  // jerk
}

bool
four_wheel_steering_msgs__msg__FourWheelSteering__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteering * lhs, const four_wheel_steering_msgs__msg__FourWheelSteering * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // front_steering_angle
  if (lhs->front_steering_angle != rhs->front_steering_angle) {
    return false;
  }
  // rear_steering_angle
  if (lhs->rear_steering_angle != rhs->rear_steering_angle) {
    return false;
  }
  // front_steering_angle_velocity
  if (lhs->front_steering_angle_velocity != rhs->front_steering_angle_velocity) {
    return false;
  }
  // rear_steering_angle_velocity
  if (lhs->rear_steering_angle_velocity != rhs->rear_steering_angle_velocity) {
    return false;
  }
  // speed
  if (lhs->speed != rhs->speed) {
    return false;
  }
  // acceleration
  if (lhs->acceleration != rhs->acceleration) {
    return false;
  }
  // jerk
  if (lhs->jerk != rhs->jerk) {
    return false;
  }
  return true;
}

bool
four_wheel_steering_msgs__msg__FourWheelSteering__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteering * input,
  four_wheel_steering_msgs__msg__FourWheelSteering * output)
{
  if (!input || !output) {
    return false;
  }
  // front_steering_angle
  output->front_steering_angle = input->front_steering_angle;
  // rear_steering_angle
  output->rear_steering_angle = input->rear_steering_angle;
  // front_steering_angle_velocity
  output->front_steering_angle_velocity = input->front_steering_angle_velocity;
  // rear_steering_angle_velocity
  output->rear_steering_angle_velocity = input->rear_steering_angle_velocity;
  // speed
  output->speed = input->speed;
  // acceleration
  output->acceleration = input->acceleration;
  // jerk
  output->jerk = input->jerk;
  return true;
}

four_wheel_steering_msgs__msg__FourWheelSteering *
four_wheel_steering_msgs__msg__FourWheelSteering__create()
{
  four_wheel_steering_msgs__msg__FourWheelSteering * msg = (four_wheel_steering_msgs__msg__FourWheelSteering *)malloc(sizeof(four_wheel_steering_msgs__msg__FourWheelSteering));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(four_wheel_steering_msgs__msg__FourWheelSteering));
  bool success = four_wheel_steering_msgs__msg__FourWheelSteering__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
four_wheel_steering_msgs__msg__FourWheelSteering__destroy(four_wheel_steering_msgs__msg__FourWheelSteering * msg)
{
  if (msg) {
    four_wheel_steering_msgs__msg__FourWheelSteering__fini(msg);
  }
  free(msg);
}


bool
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__init(four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  four_wheel_steering_msgs__msg__FourWheelSteering * data = NULL;
  if (size) {
    data = (four_wheel_steering_msgs__msg__FourWheelSteering *)calloc(size, sizeof(four_wheel_steering_msgs__msg__FourWheelSteering));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = four_wheel_steering_msgs__msg__FourWheelSteering__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        four_wheel_steering_msgs__msg__FourWheelSteering__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__fini(four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      four_wheel_steering_msgs__msg__FourWheelSteering__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

four_wheel_steering_msgs__msg__FourWheelSteering__Sequence *
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__create(size_t size)
{
  four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * array = (four_wheel_steering_msgs__msg__FourWheelSteering__Sequence *)malloc(sizeof(four_wheel_steering_msgs__msg__FourWheelSteering__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__destroy(four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * array)
{
  if (array) {
    four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__fini(array);
  }
  free(array);
}

bool
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * lhs, const four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!four_wheel_steering_msgs__msg__FourWheelSteering__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
four_wheel_steering_msgs__msg__FourWheelSteering__Sequence__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * input,
  four_wheel_steering_msgs__msg__FourWheelSteering__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(four_wheel_steering_msgs__msg__FourWheelSteering);
    four_wheel_steering_msgs__msg__FourWheelSteering * data =
      (four_wheel_steering_msgs__msg__FourWheelSteering *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!four_wheel_steering_msgs__msg__FourWheelSteering__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          four_wheel_steering_msgs__msg__FourWheelSteering__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!four_wheel_steering_msgs__msg__FourWheelSteering__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
